package com.nisum.offertransactionservice.service;

import com.nisum.offertransactionservice.client.ClientService;
import com.nisum.offertransactionservice.genericexception.GlobalApiGenericException;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.PropertySource;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Service;
import org.springframework.web.reactive.function.client.ExchangeFilterFunction;
import org.springframework.web.reactive.function.client.WebClient;
import reactor.core.publisher.Mono;

import javax.annotation.PostConstruct;

import java.util.Objects;

import static com.nisum.offertransactionservice.util.ExceptionUtil.handleError;

@Service
@PropertySource("classpath:application.properties")
@Slf4j
public class EndOfTransactionService {



    @Autowired
    ClientService clientService;

    //TODO: configuration properties instead of @Value


    public String endOfTransaction(String uuid) {
        if (Objects.isNull(uuid) || uuid.isEmpty()) {
            log.error("Offer transaction uuid is empty or null");
            throw new GlobalApiGenericException("Unable to get the Offer transaction uuid ", new Exception("exception e"), "400", false);
        }
        log.info("Store Consumer WebClient call Start");
        Mono<String> endOfTransactionRes = clientService.getStringMono(uuid);
        log.debug("Store consumer WebClient call End");
        return endOfTransactionRes.toString();
    }



}
